-----------------------------------------------------------------------
--  ado-statements-tests -- Test statements package
--  Copyright (C) 2015, 2017, 2018 Stephane Carrez
--  Written by Stephane Carrez (Stephane.Carrez@gmail.com)
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
-----------------------------------------------------------------------

with Util.Tests;
package ADO.Statements.Tests is

   procedure Add_Tests (Suite : in Util.Tests.Access_Test_Suite);

   type Test is new Util.Tests.Test with null record;

   --  Test creation of several rows in test_table with different column type.
   procedure Test_Save (T : in out Test);

   --  Test queries using the $entity_type[] cache group.
   procedure Test_Entity_Types (T : in out Test);

   --  Test executing a SQL query and getting an invalid column.
   procedure Test_Invalid_Column (T : in out Test);

   --  Test executing a SQL query and getting an invalid value.
   procedure Test_Invalid_Type (T : in out Test);

   --  Test executing a SQL query with an invalid SQL.
   procedure Test_Invalid_Statement (T : in out Test);

end ADO.Statements.Tests;
